# Small example showing how to parse nested C comments with Rockit 0.4
#
# Copyright (c) 2001 Robert Feldt, feldt@ce.chalmers.se
#
# $Id: c_comments.rb,v 1.1 2001/12/07 10:14:57 feldt Exp $
#
require 'rockit/parse/combinator_parsers'
include Rockit::Parse

# In the Rockit 0.3.X format it would look something like:
# CCommentMarker -> "/*" | "*/"
# CComment       -> "/*" ((~CCommentMarker)* | CComment)* "*/"

Marker = choice("/*", "*/")
CComment = 
  recursive("/*", mult(choice(mult(notp(Marker)), recurse)), "*/")

str = <<EOS
/****************************************************************************
** $Id: c_comments.rb,v 1.1 2001/12/07 10:14:57 feldt Exp $
**
**********************************************************************/
EOS

p CComment.parse(str)
