require 'rockit/parse/combinator_parsers'
include Rockit::Parse

print_command = string "PRINT"

valid_ascii = (0x20..0x7e).to_a.select {|c| c != '"'[0] and c != "\\"[0]}
string_character = choice(*valid_ascii.map{|c| string(c.chr)})
dquote = skip(string('"'))
string_literal = seq(dquote, mult(string_character), dquote)

white_space = skip(mult(choice(string(" "), string("\t"))))

# Difference to the book: We must use sepseq to get an Array with results,
# since the default seq will only return one large string.
command = sepseq(print_command, white_space, string_literal)
RdgBasicParser = command 

class RdgBasicEvaluator
  def eval(res)
    if Array === res && res[0] == "PRINT"
      puts res[1]
    end
  end
end

def print_eval_loop(parser, evaluator, prompt = "rdg_basic")
  while true
    print "<#{prompt}> "
    prg = STDIN.gets.chomp
    exit if prg == ":quit"
    begin
      puts "#{evaluator.eval(parser.parse(prg))}"
    rescue Exception => e
      puts e.message
    end
  end
end

if $0 == __FILE__
  puts "Welcome to Rdg Basic version 0.1.0\n\n"
  print_eval_loop(RdgBasicParser, RdgBasicEvaluator.new)
end
