require 'runit/testcase'
require 'runit/testsuite'
require 'runit/cui/testrunner'
require 'runit/topublic'
include RUNIT::ToPublic

def get_example_in_readme_file
  str = ""
  File.open("README", "r") do |f|
    while (l = f.gets)
      str << l if (l =~ /require 'rockit\/rockit'/) .. (l=~/# => /)
    end
  end
  str
end

class TestTerminalSet < RUNIT::TestCase
  def test_calculator_example_in_readme
    example = get_example_in_readme_file
    example =~ /# => (\d+)/
    expected = $1.to_i 
    begin
      actual = eval(example)
      assert_equals(expected, eval(example))
    rescue Exception
      assert(false)
    end
  end
end

# Run if we were directly called
if $0 == __FILE__
  testrunner = RUNIT::CUI::TestRunner.new
  if ARGV.size == 0
    suite = TestTerminalSet.suite
  else
    suite = RUNIT::TestSuite.new
    ARGV.each do |testmethod|
      suite.add_test(TestTerminalSet.new(testmethod))
    end
  end
  testrunner.run(suite)
end
